# -*- coding: utf-8 -*-

"""
logo actions implementation
"""

# imports #####################################################################


# actions ####################################################################

class NopAction:
	"""base class for turtle action"""
	def __repr__(self):
		args = ", ".join("%s=%s" % (k, getattr(self, k)) for k in self.__dict__)
		return '%s(%s)' % (self.__class__, args)
	
	def render(self):
		raise NotImplementedError


class Forward(NopAction):
	"""forward move"""
	def __init__(self, distance):
		self.distance = distance
	
	def render(self):
		pass


class Left(NopAction):
	"""left turn"""
	def __init__(self, angle):
		self.angle = angle
	
	def render(self):
		pass


class Home(NopAction):
	"""go back at home"""
	def render(self):
		pass


class Color(NopAction):
	"""change trace color"""
	def __init__(self, color):
		self.color = color
	
	def render(self):
		pass


class Pen(NopAction):
	"""drawing state"""
	def __init__(self, down=True):
		self.down = down
	
	def render(self):
		pass
