#!/usr/bin/env python
# -*- coding: utf-8 -*-


# imports #####################################################################

import sys
import threading

from OpenGL.GL import *
from OpenGL.GLUT import *

from interpreter import Interpreter


# globals ####################################################################

TURTLE = [(-5, 0), (0, 10), (5, 0)]
interpreter = Interpreter()


# display ####################################################################

def init_opengl():
	"""setting opengl state."""
	# clear color
	pass
	
	# line antialiasing
	pass	


def reshape(width, height):
	"""window reshape callback"""
	# setting viewport
	pass
	
	# setting projection and modelview matricies
	pass


def display():
	"""window redisplay callback"""
	# clearing back buffer
	pass
	
	# setting model view
	pass
	
	# rendering turtle trace in back buffer ...
	pass
	
	# ... and the turtle
	glBegin(GL_LINE_LOOP)
	for (x, y) in TURTLE:
		glVertex(x, y)
	glEnd()
	
	# swapping back & front buffers
	glutSwapBuffers()


# glut based viewer ##########################################################

def init_glut(argv):
	"""setting up window"""
	glutInit(argv)
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE)
	glutCreateWindow(argv[0])
	glutReshapeFunc(reshape)
	glutDisplayFunc(display)
	autorefresh()

def autorefresh(_=None):
	"""redisplaying every 20th of second"""
	glutPostRedisplay()
	glutTimerFunc(50, autorefresh, _)


# main #######################################################################

def main(argv=None):
	if argv == None:
		argv = sys.argv
			
	init_glut(argv)
	interpreter_thread = threading.Thread(target=interpreter.cmdloop)
	interpreter_thread.start()

	init_opengl()
	glutMainLoop()


if __name__ == "__main__":
	sys.exit(main())
